#ifndef DNSADDRESSRECORDFORM_H
#define DNSADDRESSRECORDFORM_H

#include <gtkmm/table.h>
#include <gtkmm/entry.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/box.h>

#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include <openwbem/OW_CIMProperty.hpp>
#include "Form.h"

class DnsAddressRecordForm : public Form
{
private:
	// keep handle to the instance this form is representing
	OpenWBEM::Reference<OpenWBEM::CIMInstance> inst;

	// widgets on the form
	Gtk::Table table;
	Gtk::Label name_label, address_label;
	Gtk::Entry name_entry, address_entry;

	// fills in widgets with current values of instance
	void update();

public:
	// CONSTRUCTOR
	DnsAddressRecordForm();

	// METHODS DEFINED IN Form
	virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
			OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
	virtual Gtk::Widget *getWidget();
	virtual void applyChanges();
};

#endif /* DNSADDRESSRECORDFORM_H */
