#ifndef DNSMXRECORDFORM_H
#define DNSMXRECORDFORM_H

#include <gtkmm/table.h>
#include <gtkmm/entry.h>
#include <gtkmm/spinbutton.h>

#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include "Form.h"

class DnsMXRecordForm : public Form
{
private:
	// keep handle to the instance this form is representing
	OpenWBEM::Reference<OpenWBEM::CIMInstance> inst;

	// widgets on the form
	Gtk::Table table;
	Gtk::Label name_label, server_label, priority_label;
	Gtk::Entry name_entry, server_entry;
	Gtk::SpinButton priority_entry;

	// fills in widgets with current values of instance
	void update();

public:
	// CONSTRUCTOR
	DnsMXRecordForm();

	// METHODS DEFINED IN Form
	virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
			OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
	virtual Gtk::Widget *getWidget();
	virtual void applyChanges();
};

#endif /* DNSMXRECORDFORM_H */
