#ifndef NAGIOSHOSTDIALOG_H
#define NAGIOSHOSTDIALOG_H

#include <gtkmm/dialog.h>
#include <gtkmm/notebook.h>
#include <gtkmm/table.h>
#include <gtkmm/textview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/separator.h>

#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include <openwbem/OW_CIMProperty.hpp>
#include "NagiosServiceList.h"
#include "ModifyInstanceDialog.h"
#include "CIMInstanceProxy.h"


class NagiosHostDialog : public ModifyInstanceDialog
{
public:
	// notebook tab "General"
	class GeneralForm : public Form
	{
	private:
		// keep handle to the instance this form represents
		OpenWBEM::Reference<OpenWBEM::CIMInstance> inst;

		Gtk::VBox general_vbox;
		Gtk::HBox general_header_hbox;
		Gtk::VBox general_header_vbox;
		Gtk::Table general_table;
		Gtk::Label general_host_name,
				general_host_address,
				general_status_label,
				general_status,
				general_last_check_label,
				general_last_check,
				general_output_label;
		Gtk::VBox general_output_vbox;
		Gtk::HSeparator general_separator;
		Gtk::ScrolledWindow general_output_scrolled;
		Gtk::TextView general_output_textview;

		void update();
	
	public:
		// Constructor
		GeneralForm();

		// Methods defined in Form
		virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
				OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
		virtual Gtk::Widget *getWidget();
		virtual void applyChanges();
	};

	// notebook tab "Services"
	class ServicesForm : public Form
	{
	private:
		// keep handle to the instance this form represents
		OpenWBEM::CIMObjectPath cop;

		// widgets
		Gtk::ScrolledWindow services_scrolled;
		NagiosServiceList services_list;

		void update();
	
	public:
		// Constructor
		ServicesForm();

		// Methods defined in Form
		virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
				OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
		virtual Gtk::Widget *getWidget();
		virtual void applyChanges();
	};

	// CONSTRUCTOR
	NagiosHostDialog(OpenWBEM::CIMObjectPath cop);
	NagiosHostDialog(CIMInstanceHandle host_handle);
};

#endif /* NAGIOSHOSTDIALOG_H */
