#ifndef NAGIOSHOSTLIST_H
#define NAGIOSHOSTLIST_H

#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <openwbem/OW_CIMOMHandleIFC.hpp>
#include <openwbem/OW_CIMInstance.hpp>

class NagiosHostList : public Gtk::TreeView
{
private:
	Glib::RefPtr<Gtk::ListStore> m_store;

public:
	NagiosHostList();
	void show_hostgroup(OpenWBEM::CIMObjectPath hostgroup_cop);

private:
	class ModelColumns : public Gtk::TreeModel::ColumnRecord
	{
	public:
		ModelColumns()
		{
			add(host);
			add(status);
			add(last_check);
			add(duration);
			add(information);
			add(status_color);
			add(instobj);
		}
		Gtk::TreeModelColumn<Glib::ustring> host;
		Gtk::TreeModelColumn<Glib::ustring> status;
		Gtk::TreeModelColumn<Glib::ustring> last_check;
		Gtk::TreeModelColumn<Glib::ustring> duration;
		Gtk::TreeModelColumn<Glib::ustring> information;
		Gtk::TreeModelColumn<Glib::ustring> status_color;
		Gtk::TreeModelColumn<OpenWBEM::CIMInstance> instobj;
	};
	
	ModelColumns Columns;

protected:
	static time_t convertTime(OpenWBEM::CIMDateTime x);
	static Glib::ustring duration2string(time_t seconds);
	virtual void on_instance_activated(OpenWBEM::CIMInstance inst);
	virtual void on_row_activated(const Gtk::TreeModel::Path &path,
			Gtk::TreeViewColumn *column);
};

#endif /* NAGIOSHOSTLIST_H */
