#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

// Nagios plugin headers
#include "NagiosPlugin.h"
#include "NagiosWindow.h"
#include "NagiosHostDialog.h"
#include "StatusMapWindow.h"

// CIMBrowser headers
#include "ClassHandlerRegistry.h"
#include "ModifyInstanceDialog.h"
#include "InstancePropertyListForm.h"
#include <iostream>

#include <libgnomecanvasmm/init.h>

using namespace OpenWBEM;
using namespace Gtk;

class NagiosServiceHandler : public ClassHandler
{
	virtual void do_properties(const CIMObjectPath &cop, Window *parent_window)
	{
		NagiosWindow *nagios = new NagiosWindow(cop);
		nagios->show();
	}
};

class NagiosHostHandler : public ClassHandler
{
	virtual void do_properties(const CIMObjectPath &cop, Window *parent_window)
	{
		NagiosHostDialog *dlg = new NagiosHostDialog(cop);
		dlg->set_transient_for(*parent_window);
		dlg->show();
	}
};

class StatusMapHandler : public ClassHandler
{
public:
	virtual void do_properties(const CIMObjectPath &cop, Window *parent_window)
	{
	}

	class StatusMapScopeItem : public DefaultInstanceScopeItem
	{
	public:
		StatusMapScopeItem(const CIMObjectPath &cop, MainWindow *main_window)
			: DefaultInstanceScopeItem(cop, main_window)
		{
		}

		virtual void activate()
		{
			CIMInstanceHandle handle(CIMInstanceProxy::create(cop));
			StatusMapWindow *window = new StatusMapWindow(handle);
			window->show();
		}
	};

	virtual ScopeItemRef create_scope_item(const CIMObjectPath &cop,
		MainWindow *main_window)
	{
		return ScopeItemRef(new StatusMapScopeItem(cop, main_window));
	}
};

extern "C" {
void
init_plugin()
{		
	// initialize Gnome Canvas library
	Gnome::Canvas::init();

	ClassHandlerRegistry::add_handler("Config4GNU_NagiosService",
		new NagiosServiceHandler);
	ClassHandlerRegistry::add_handler("Config4GNU_NagiosMonitoredHost",
		new NagiosHostHandler);
	ClassHandlerRegistry::add_handler("Config4GNU_NagiosStatusMap",
		new StatusMapHandler);
}
} // end extern "C" block
