#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "SelectHostDialog.h"
#include "CIMOMHandle.h"
#include <gtkmm/stock.h>

using namespace Gtk;
using namespace Glib;
using namespace OpenWBEM;

SelectHostDialog::SelectHostDialog()
{
	set_title("Select Host");
	set_default_size(300, 300);

	hosts_store = ListStore::create(Columns);
	hosts_view.set_model(hosts_store);
	hosts_view.append_column("Host", Columns.name);
	hosts_view.show();
	hosts_scrolled.add(hosts_view);

	hosts_scrolled.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC);
	hosts_scrolled.set_shadow_type(SHADOW_IN);
	hosts_scrolled.show();
	get_vbox()->pack_start(hosts_scrolled);

	add_button(Stock::CANCEL, RESPONSE_CANCEL);
	add_button(Stock::OK, RESPONSE_OK);
	set_default_response(RESPONSE_OK);

	init_hosts_list();
}

void
SelectHostDialog::init_hosts_list()
{
	CIMInstanceEnumeration result = CIMOMHandle::enumInstancesE(
			"Config4GNU_NagiosMonitoredHost");
	while (result.hasMoreElements())
	{
		CIMInstance inst = result.nextElement();
		TreeIter iter = hosts_store->append();
		TreeRow row = *iter;

		String string;
		string = inst.getProperty("ElementName").getValue().toString();
		row[Columns.name] = string.c_str();
		row[Columns.handle] = CIMInstanceProxy::create(
				CIMObjectPath(CIMOMHandle::getDefaultNamespace(),
						inst));
	}
}

CIMInstanceHandle
SelectHostDialog::get_selection() const
{
	TreePath path;
	TreeViewColumn *column;

	const_cast<TreeView&>(hosts_view).get_cursor(path, column);
	TreeIter iter = hosts_store->get_iter(path);
	TreeRow row = *iter;

	return row[Columns.handle];
}
