#ifndef SELECTHOSTDIALOG_H
#define SELECTHOSTDIALOG_H

#include "CIMInstanceProxy.h"
#include <gtkmm/dialog.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <openwbem/OW_CIMProperty.hpp>
#include <openwbem/OW_CIMValue.hpp>

class SelectHostDialog : public Gtk::Dialog
{
private:
	Gtk::ScrolledWindow hosts_scrolled;
	Gtk::TreeView hosts_view;
	Glib::RefPtr<Gtk::ListStore> hosts_store;

	class MyColumnRecord : public Gtk::TreeModel::ColumnRecord
	{
	public:
		MyColumnRecord()
		{
			add(name);
			add(handle);
		}
		Gtk::TreeModelColumn<Glib::ustring> name;
		Gtk::TreeModelColumn<CIMInstanceHandle> handle;
	};
	MyColumnRecord Columns;

	void init_hosts_list();

public:
	SelectHostDialog();
	CIMInstanceHandle get_selection() const;
};

#endif /* SELECTHOSTDIALOG_H */
