#ifndef SAMBASHAREGENERALFORM_H
#define SAMBASHAREGENERALFORM_H

#include <gtkmm/table.h>
#include <gtkmm/entry.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/box.h>

#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMInstance.hpp>
#include <openwbem/OW_CIMProperty.hpp>
#include "Form.h"

class SambaShareGeneralForm : public Form
{
private:
	// keep handle to the instance this form is representing
	OpenWBEM::Reference<OpenWBEM::CIMInstance> inst;

	// notebook tab "General"
	Gtk::Table general_table;
	Gtk::Label general_share_name_label,
			general_path_label, general_comment_label, general_access_label;
	Gtk::Entry general_share_name_entry,
			general_path_entry, general_comment_entry;
	Gtk::RadioButton_Helpers::Group general_access_group;
	Gtk::RadioButton general_access_readonly, general_access_writeable;
	Gtk::HBox general_access_box;

	// fills in widgets with current values of instance
	void update();


public:
	// CONSTRUCTOR
	SambaShareGeneralForm();

	// METHODS DEFINED IN Form
	virtual void set_instance(const OpenWBEM::CIMObjectPath &cop,
			OpenWBEM::Reference<OpenWBEM::CIMInstance> inst);
	virtual Gtk::Widget *getWidget();
	virtual void applyChanges();
};

#endif /* SAMBASHAREGENERALFORM_H */
