// Copyright 2004 Jason Long

// This file is part of cimbrowser.
//
// Cimbrowser is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Cimbrowser is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Cimbrowser; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef ADDCIMOBJECTDIALOG_H
#define ADDCIMOBJECTDIALOG_H

#include <gtkmm/dialog.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <openwbem/OW_CIMObjectPath.hpp>
#include <openwbem/OW_CIMProperty.hpp>
#include <openwbem/OW_Array.hpp>

class AddCIMObjectDialog : public Gtk::Dialog
{
private:
	// WIDGETS
	Gtk::HBox class_hbox;
	Gtk::Label class_label;
	Gtk::Entry class_entry;
	Gtk::Label keys_label;
	Gtk::ScrolledWindow keys_scrolled;
	Gtk::TreeView keys_view;
	Glib::RefPtr<Gtk::ListStore> keys_store;

	// PROPERTIES
	OpenWBEM::String cur_class_name;
	OpenWBEM::CIMPropertyArray props;

public:
	AddCIMObjectDialog();

	OpenWBEM::CIMObjectPath get_object_path() const;

protected:
	void on_entry_focus(Gtk::DirectionType direction);
	void on_value_edited(const Glib::ustring &path,
			const Glib::ustring &new_text);
	void update_keys();

	class KeysModelColumns : public Gtk::TreeModel::ColumnRecord
	{
	public:
		KeysModelColumns()
		{
			add(name);
			add(value);
			add(propindex);
		}
		Gtk::TreeModelColumn<Glib::ustring> name;
		Gtk::TreeModelColumn<Glib::ustring> value;
		Gtk::TreeModelColumn<int> propindex;
	};
	
	KeysModelColumns KeysColumns;
};

#endif /* ADDCIMOBJECTDIALOG_H */
