// Copyright 2004 Jason Long

// This file is part of cimbrowser.
//
// Cimbrowser is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Cimbrowser is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Cimbrowser; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "AssociatorClassList.h"
#include "ClassInformationDialog.h"
#include "CIMOMHandle.h"

#include <openwbem/OW_CIMProtocolIFC.hpp>
#include <openwbem/OW_HTTPClient.hpp>
#include <openwbem/OW_CIMXMLCIMOMHandle.hpp>
#include <openwbem/OW_Enumeration.hpp>
#include <openwbem/OW_CIMException.hpp>
#include <openwbem/OW_CIMObjectPath.hpp>

using namespace Gtk;
using namespace OpenWBEM;

AssociatorClassList::AssociatorClassList()
{
}

void
AssociatorClassList::set_base_class(String className)
{
	set_associator_base_class(CIMObjectPath(className));
}

void
AssociatorClassList::set_associator_base_class(CIMObjectPath className)
{
	m_store->clear();

	try
	{
		CIMClassEnumeration result;
		result = CIMOMHandle::referencesClassesE(className);
		while (result.hasMoreElements())
		{
			CIMClass klass = result.nextElement();
			Glib::ustring classname = klass.getName().c_str();
			
			TreeModel::iterator iter = m_store->append();
			TreeModel::Row row = *iter;
			
			row[m_Columns.classname] = classname;
			row[m_Columns.classobj] = klass;
			
			//expand_subclasses(klass, row);
		}
	}
	catch (CIMException e)
	{
		g_warning("%s", e.getMessage());
	}
}
