// Copyright 2004 Jason Long

// This file is part of cimbrowser.
//
// Cimbrowser is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Cimbrowser is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Cimbrowser; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include "InstancePropertyListForm.h"

using namespace Gtk;
using namespace OpenWBEM;

InstancePropertyListForm::InstancePropertyListForm()
{
	properties_list.show();

	properties_scrolled.set_shadow_type(SHADOW_IN);
	properties_scrolled.set_border_width(6);
	properties_scrolled.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC);
	properties_scrolled.add(properties_list);
}

InstancePropertyListForm::InstancePropertyListForm(CIMInstanceHandle instHandle)
	: properties_list(instHandle)
{
	properties_list.show();

	properties_scrolled.set_shadow_type(SHADOW_IN);
	properties_scrolled.set_border_width(6);
	properties_scrolled.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC);
	properties_scrolled.add(properties_list);
}

void
InstancePropertyListForm::set_instance(const CIMObjectPath &cop,
		Reference<CIMInstance> inst)
{
	CIMInstanceHandle instHandle = CIMInstanceProxy::create(cop);
	properties_list.list_properties(instHandle);
}

Widget *
InstancePropertyListForm::getWidget()
{
	return &properties_scrolled;
}

void
InstancePropertyListForm::applyChanges()
{
	properties_list.applyChanges();
}
